<?php
header('Content-type: text/html; charset=UTF-8');
echo '<?xml version="1.0" encoding="UTF-8"?>' . "\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>Jabber Roster Utility in PHP</title>
</head>
<body>

<h1>Jabber Roster Utility in PHP</h1>

<p>
This is a remake of the famous <a href="http://jru.jabberstudio.org/">Jabber Roster Utility</a>, written in Perl, porting it to the <a href="http://php.net/">PHP</a> language, using the <a href="http://cjphp.netflint.net/">Class.Jabber.PHP</a>.<br />
With this tool, you can manage your <a href="http://jabber.org/">Jabber</a> roster, add, remove and alter items in a large scale.
</p>

<hr />

<h2>Jabber account data</h2>

<form method="post">

<p>
Enter your JID (user@server):
<input type="text" name="jid" size="30" value="<?php echo htmlentities($_REQUEST['jid']); ?>" /> <small>(you can also say user@domain:port if you need to)</small><br />
Enter your password:
<input type="password" name="password" size="20" value="<?php echo htmlentities($_REQUEST['password']); ?>" /><br />
<input type="submit" name="getroster" value="Retrieve roster from the server" />
</p>

<?php
if ($_REQUEST['getroster'] != '' ||
    $_REQUEST['updateroster'] != '')
{
	$jid = $_REQUEST['jid'];
	$password = $_REQUEST['password'];

	if (!preg_match('/^([a-z0-9.\\-_]+)@([a-z0-9.\\-]+)(:[0-9]+)?$/i', $jid, $m))
	{
		echo '<p><b>The JID you entered is invalid.</b></p>';
		echo '</form>';
		echo '</body></html>';
		exit();
	}
	$username = $m[1];
	$server = $m[2];
	$port = $m[3] or $port = 5222;

	@include('class.jabber.php');
	if (!class_exists('Jabber'))
	{
		echo '<p><b>Class.Jabber.PHP could not be loaded. Make sure, it\'s here and named "class.jabber.php".</b></p>';
		echo '</form>';
		echo '</body></html>';
		exit();
	}

	$J = new Jabber();
	$J->server = $server;
	$J->port = $port;
	$J->username = $username;
	$J->password = $password;
	$J->resource = 'JRUPHP';

	if (!$J->Connect())
	{
		echo '<p><b>Could not connect to the Jabber server. Check your account data.</b></p>';
		echo '</form>';
		echo '</body></html>';
		exit();
	}
	if (!$J->SendAuth())
	{
		echo '<p><b>Could not authenticate to the Jabber server. Check your account data.</b></p>';
		echo '</form>';
		echo '</body></html>';
		exit();
	}
}

if ($_REQUEST['updateroster'] != '')
{
	$add = array();
	$remove = array();

	$roster = explode("\n", $_REQUEST['roster']);
	foreach ($roster as $line)
	{
		$line = trim($line);
		if (substr($line, 0, 1) == '+')
		{
			$line = trim(substr($line, 1));
			$c = explodeQuoted(';', $line);
			$contact = array(
				'jid' => $c[0],
				'name' => $c[1],
				'sub' => $c[2],
				'group' => $c[3]);
			$add[] = $contact;
		}
		if (substr($line, 0, 1) == '-')
		{
			$line = trim(substr($line, 1));
			$c = explodeQuoted(';', $line);
			$contact = array(
				'jid' => $c[0],
				'name' => $c[1],
				'sub' => $c[2],
				'group' => $c[3]);
			$remove[] = $contact;
		}
	}

	foreach ($remove as $contact)
	{
		$J->RosterRemoveUser($contact['jid'], NULL, false);
	}

	foreach ($add as $contact)
	{
		$J->RosterAddUser($contact['jid'], NULL, $contact['name'], $contact['group'], false);
		if ($contact['sub'] == 'to' || $contact['sub'] == 'both')
		{
			$J->Subscribe($contact['jid']);
		}
		if ($contact['sub'] == 'from' || $contact['sub'] == 'both')
		{
			$J->SubscriptionAcceptRequest($contact['jid']);
		}
	}

	echo '<p><i>Roster updated. Below is your new roster.</i></p>';
}

if ($_REQUEST['getroster'] != '' ||
    $_REQUEST['updateroster'] != '')
{
	$J->RosterUpdate();

	echo '<h2>Roster contents</h2>';

	echo '<p>';
	echo 'These are the four columns: JID, name, subscription (none, to, from, both) and group name.<br />';
	echo 'They\'re semicolon-separated and if they contain semicolons, they\'re additionally double-quoted.<br />';
	echo '<textarea name="roster" cols="80" rows="15">';
	foreach ($J->roster as $contact)
	{
		echo quoteIfRequired(';', $contact['jid']) . ';' .
			quoteIfRequired(';', $contact['name']) . ';' .
			quoteIfRequired(';', $contact['subscription']) . ';' .
			quoteIfRequired(';', $contact['group']) . "\n";
	}
	echo '</textarea>';
	echo '</p>';

	echo '<p>';
	echo 'To make changes to your roster, modify the above content and hit the "Update" button.<br />';
	echo 'You can <b>add</b> contacts by putting a <b>+</b> sign at the beginning of the line. To <b>remove</b> a contact, put a <b>-</b> there.<br />';
	echo '<input type="submit" name="updateroster" value="Update my roster" />';
	echo '</p>';

	$J->Disconnect();
}
?>

</form>

<hr />

<p>
<small>&copy; 2005 by <a href="http://unclassified.de">Yves Goergen</a>, released under the terms of the <a href="http://www.gnu.org/licenses/gpl.html">GNU GPL license</a>.</small>
</p>

</body>
</html>

<?php

function quoteIfRequired($sep, $str)
{
	if (strpos($str, $sep) !== false) return '"' . $str . '"';
	return $str;
}

// Same as PHP function explode(), but also splits by "..."
//
// in sep: separator character, see PHP explode()
// in str: string to split, see PHP explode()
// in mask_bs (bool): take case of \ characters, and ignore \" f.ex. [currently ignored to true]
// in keep (bool): keep the quotes around quoted parts
// out: array
//
function explodeQuoted($sep, $str, $mask_bs = true, $keep = false)
{
	$out = array();
	$len = strlen($str);
	$instr = false;   // are we currently inside a string?
	$pos = 0;         // current starting position
	$startpos = 0;    // remember last part beginning
	$pos_s = -1;      // position of ' ' (space) / separator
	$pos_q = -1;      // position of '"' (quote)

	$keep = $keep ? 1 : 0;   // keep " quotes

	while ($pos < $len)
	{
		if ($pos_s < $pos)   // only search if last result is before current position
			if (($pos_s = strpos($str, $sep, $pos)) === false) $pos_s = $len;
				// set pointer to end of string, if symbol was not found
		if ($pos_q < $pos)
			if (($pos_q = strpos($str, '"', $pos)) === false) $pos_q = $len;

		$minpos = min($pos_s, $pos_q);   // find the nearest interesting symbol

		if ($instr === false && $minpos === $pos_s)   // found a space/separator first (not inside a string)
		{
			$out[] = str_replace(
				'\\"',
				'"',
				substr($str, $startpos, $minpos - $startpos));
			$startpos = $pos = $minpos + 1;
		}
		elseif ($minpos === $pos_q)   // found a quote first
		{
			if ($minpos === $startpos && $instr === false)   // first symbol of this part AND not inside a string (must be so)
			{
				$instr = true;
				$startpos = $pos = $minpos - $keep + 1;   // jump over beginning "
			}
			elseif ($instr === true && $str{$minpos - 1} !== '\\' && ($str{$minpos + 1} === $sep
			                                                          || $minpos === $len - 1))
				// inside a string AND previous symbol is not \ AND next symbol is space/separator
				//                                                  OR no more characters (last symbol)
			{
				$instr = false;
				$out[] = str_replace(
					'\\"',
					'"',
					substr($str, $startpos, $minpos - $startpos + $keep));
				$startpos = $pos = $minpos + 2;   // jump over quote + separator
			}
			/*
			elseif ($instr === false && $str{$minpos - 1} === '\\')
				// not inside a string AND previous symbol is \
			*/
			else   // found something of no interest
			{
				$pos = $minpos + 1;
			}
		}
		else   // found something of no interest
		{
			$pos = $minpos + 1;
		}
	}

	// Something left?
	if ($startpos < $pos)
	{
		$out[] = str_replace(
			'\\"',
			'"',
			substr($str, $startpos, $pos - $startpos));
	}

	return $out;
}

?>